// *** 7 Colors for Windows CE ***
// Version 1.4
// Franois PESSAUX June 2001
// This program is freeware
// Use its sources as you want provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot
//   --Francois

// 7Colors.cpp : Defines the entry point for the application.

#include "stdafx.h"
#include "resource.h"



void disable_buttons ()
{
	SendMessage (button_band_handle, TB_ENABLEBUTTON, IDB_GRAY_BUTTON, (LPARAM) MAKELONG (FALSE, 0)) ;
	SendMessage (button_band_handle, TB_ENABLEBUTTON, IDB_RED_BUTTON, (LPARAM) MAKELONG (FALSE, 0)) ;
	SendMessage (button_band_handle, TB_ENABLEBUTTON, IDB_GREEN_BUTTON, (LPARAM) MAKELONG (FALSE, 0)) ;
	SendMessage (button_band_handle, TB_ENABLEBUTTON, IDB_BLUE_BUTTON, (LPARAM) MAKELONG (FALSE, 0)) ;
	SendMessage (button_band_handle, TB_ENABLEBUTTON, IDB_CYAN_BUTTON, (LPARAM) MAKELONG (FALSE, 0)) ;
	SendMessage (button_band_handle, TB_ENABLEBUTTON, IDB_MAGENTA_BUTTON, (LPARAM) MAKELONG (FALSE, 0)) ;
	SendMessage (button_band_handle, TB_ENABLEBUTTON, IDB_YELLOW_BUTTON, (LPARAM) MAKELONG (FALSE, 0)) ;
}


void refresh_screen (struct game *game, HWND w_handle)
{
  int i, line, col ;
  int x, y ;
  POINT diamond[4] ;
  struct cell *board ;
  int width, height, x0 ;
  PAINTSTRUCT paint_struct ;
  HDC disp_dev_handle ;
  HDC dbl_disp_dev_handle ;
  HBITMAP old_bitmap, dbl_bitmap_handle ;
	HBRUSH old_brush ;

  // Setup things for the double buffering.
  BeginPaint (w_handle, &paint_struct) ;
  disp_dev_handle = GetWindowDC (w_handle) ;
  dbl_disp_dev_handle = CreateCompatibleDC (disp_dev_handle) ;
	dbl_bitmap_handle = CreateCompatibleBitmap (disp_dev_handle, 240, 320) ;
	// Don't forget to backup the current to restore it later otherwise you'll get into a huge MEMORY LEAK !
  old_bitmap = (HBITMAP) SelectObject (dbl_disp_dev_handle, dbl_bitmap_handle) ;

	// Draws the window background.
	diamond[0].x = 0 ;
	diamond[0].y = 0 ;
	diamond[1].x = 240 ;
	diamond[1].y = 0 ;
	diamond[2].x = 240 ;
	diamond[2].y = 320 ;
	diamond[3].x = 0 ;
	diamond[3].y = 320 ;
	// Don't forget to backup the current to restore it later otherwise you'll get into a huge MEMORY LEAK !
	old_brush = (HBRUSH) SelectObject (dbl_disp_dev_handle, (HBRUSH) intro_brush) ;
	Polygon (dbl_disp_dev_handle, diamond, 4) ;
	// Don't forget to restore the old object otherwise you'll get into a huge MEMORY LEAK !
	SelectObject (dbl_disp_dev_handle, old_brush) ;

	if (current_game != NULL) {
		board = game->board ;
		width = (14 * board_width + 7) + 1 ;
		height = (14 * board_height + 7) + 1 ;
		x0 = (240 - width) / 2 ;
		y = button_band_height ;  // // The amount of space to avoid the button bar to overlap the board

		// Draws the background of the board.
		diamond[0].x = x0 ;
		diamond[0].y = y ;
		diamond[1].x = x0 + width ;
		diamond[1].y = y ;
		diamond[2].x = x0 + width ;
		diamond[2].y = y + height ;
		diamond[3].x = x0 ;
		diamond[3].y = y + height ;
		// Don't forget to backup the current to restore it later otherwise you'll get into a huge MEMORY LEAK !
		old_brush = (HBRUSH) SelectObject (dbl_disp_dev_handle, GetStockObject (BLACK_BRUSH)) ;
		Polygon (dbl_disp_dev_handle, diamond, 4) ;
		// Don't forget to restore the old object otherwise you'll get into a huge MEMORY LEAK !
		SelectObject (dbl_disp_dev_handle, old_brush) ;

		// Draw the diamonds
		for (line=0; line<board_height * 2; line++) {
			if (line % 2 == 0) x = x0 + 7 ;
			else x = x0 ;
			for (col=0; col<board_width; col++) {
				diamond[0].x = x + 7 ;
				diamond[0].y = y + 1 ;
				diamond[1].x = x + 13 ;
				diamond[1].y = y + 7 ;
				diamond[2].x = x + 7 ;
				diamond[2].y = y + 13 ;
				diamond[3].x = x + 1 ;
				diamond[3].y = y + 7 ;
				i = (line * board_width) + col ;
				// Don't forget to backup the current to restore it later otherwise you'll get into a huge MEMORY LEAK !
				old_brush = (HBRUSH) SelectObject (dbl_disp_dev_handle, color_brushes[board[i].color]) ;
				Polygon (dbl_disp_dev_handle, diamond, 4) ;
				// Don't forget to restore the old object otherwise you'll get into a huge MEMORY LEAK !
				SelectObject (dbl_disp_dev_handle, old_brush) ;
				x += 14 ;
				}
			y += 7 ;
			}
		
		// Highlight current player starting location
		if (turn == OWNER_PLAYER0) {
			diamond[0].x = x0 + 7 ;
			// button_band_height is indeed the amount of space to avoid the button bar to overlap the board
			diamond[0].y = button_band_height + 7 * (board_height * 2) - 7 ;
			diamond[1].x = diamond[0].x  ;
			diamond[1].y = diamond[0].y + 14 ;
			diamond[2].x = x0 ;
			diamond[2].y = diamond[0].y + 7 ;
			}
		else {
			diamond[0].x = x0 + 14 * board_width ;
			diamond[0].y = button_band_height ;			// The amount of space to avoid the button bar to overlap the board
			diamond[1].x = diamond[0].x ;
			diamond[1].y = diamond[0].y + 14 ;
			diamond[2].x = diamond[0].x + 7 ;
			diamond[2].y = diamond[0].y + 7 ;
			}

		// Don't forget to backup the current to restore it later otherwise you'll get into a huge MEMORY LEAK !
		old_brush = (HBRUSH) SelectObject (dbl_disp_dev_handle, (HBRUSH) GetStockObject (WHITE_BRUSH)) ;
		Polygon (dbl_disp_dev_handle, diamond, 3) ;
		// Don't forget to restore the old object otherwise you'll get into a huge MEMORY LEAK !
		SelectObject (dbl_disp_dev_handle, old_brush) ;
		}
	else {
		// Draws the prompt for a new game (240x112 bitmap).
		TransparentImage (dbl_disp_dev_handle,
			0, 50, 240, 112,
			(HANDLE) prompt_bm_handle,
			0, 0, 240, 112,
			RGB (255,255,255)) ;
		}

	// Actual screen refresh (double buffering transfer)
	// paint_struct.rcPaint.top takes into account the band height.
	// The standard upper menubar is not part of the area, so we must not
	// get worried about it and we can forget it. 0 is the first visible
	// pixel in the window, under the standard upper menubar.
	// Indeed bu transfering from paint_struct.rcPaint.top to
	// paint_struct.rcPaint.top, we only transfer the visible part of the
	// window. The only thing is that we always draw in the double buffer
	// from a height that is equal to the button bar height. So that, the
	// status bar is allowed to overlap the game, but not the button bar
	// is allowed this. So we are sure that the board will only be displayed
	// below the button bar. Indeed we allow the status bar to hide a part
	// of the board because we consider that this bar is not very important
	// and can be folded just after being used to check the game status.
	// Yep, this bar is mostly intended to be read once sometimes, not to
	// stay unfolded everytime. On the other side, the buttons bar is something
	//really important and that must be accessible everytime !
  BitBlt (disp_dev_handle,
	  paint_struct.rcPaint.left,
	  paint_struct.rcPaint.top,
	  paint_struct.rcPaint.right - paint_struct.rcPaint.left,
	  paint_struct.rcPaint.bottom - paint_struct.rcPaint.top,
	  dbl_disp_dev_handle,
	  paint_struct.rcPaint.left,
		paint_struct.rcPaint.top,
	  SRCCOPY) ;

	// Don't forget to restore the old object otherwise you'll get into a huge MEMORY LEAK !
	SelectObject (dbl_disp_dev_handle, old_bitmap) ;

	// Now release object themselves.
  DeleteObject (dbl_bitmap_handle) ;
  DeleteDC (dbl_disp_dev_handle) ;
  ReleaseDC (w_handle, disp_dev_handle) ;
  EndPaint (w_handle, &paint_struct) ;
}


void switch_authorized_color ()
{
	int i ;

	// First disable every buttons.
	disable_buttons () ;
	// Now, enable some of them.
	for (i = COLOR_GRAY; i <= COLOR_YELLOW; i++) {
		if ((i != players[OWNER_PLAYER0].pcolor) && (i != players[OWNER_PLAYER1].pcolor))
			SendMessage (button_band_handle, TB_ENABLEBUTTON, IDB_GRAY_BUTTON+i, (LPARAM) MAKELONG (TRUE, 0)) ;
	}
}



void update_status ()
{
  double percent0, percent1 ;

  percent0 = ((double) (players[OWNER_PLAYER0].pcount)) /
    (current_game->board_array_size - current_game->number_forbidden_cells) * 100.0 ;
  percent1 = ((double) (players[OWNER_PLAYER1].pcount)) /
    (current_game->board_array_size - current_game->number_forbidden_cells) * 100.0 ;
  wsprintf (tmp_string, TEXT ("%s %2.1f %% %s %2.1f %%"),
	    players[OWNER_PLAYER0].pname, percent0,
			players[OWNER_PLAYER1].pname, percent1) ;
  SetWindowText (t_player_handle, tmp_string) ;
}



LRESULT CALLBACK EndGameDialogHandler (HWND w_handle, UINT message,
				       WPARAM w_param, LPARAM l_param)
{
  int wm_id ;
  double percent0, percent1 ;
  HWND tmpw_handle ;

  wm_id = LOWORD (w_param) ;

  switch (message) {
		case WM_INITDIALOG:
			percent0 = ((double) (players[OWNER_PLAYER0].pcount)) /
				current_game->board_array_size * 100.0 ;
			percent1 = ((double) (players[OWNER_PLAYER1].pcount)) /
				current_game->board_array_size * 100.0 ;
			tmpw_handle = GetDlgItem (w_handle, IDC_STATIC_ENDGAME) ;
			if (percent0 > percent1)
				wsprintf (tmp_string, TEXT ("%s is winner !"), players[OWNER_PLAYER0].pname) ;
			else
				wsprintf (tmp_string, TEXT ("%s is winner !"), players[OWNER_PLAYER1].pname) ;
			SetWindowText (tmpw_handle, tmp_string) ;
			return (TRUE) ;
			break ;															// End of WM_INITDIALOG

		case WM_COMMAND:
			switch (wm_id) {
				case IDB_ENDGAME_OK:
					EndDialog (w_handle, TRUE) ;
					return (TRUE) ;
					break ;													// End of IDB_ENDGAME_OK
				}																	// End of switch (wm_id)
			break ;															// End of WM_COMMAND
		}																			// End of switch (message)
	
	// Force default handling by the system (because we're
  // in the case of a dialog handler). Calling DefWindowProc is only the
  // protocol for window handlers
  return (FALSE) ;
}




void handle_color_button_press (int wm_id, HWND w_handle)
{
  int tmp_color, count ;
 
  if (running_game) {
		tmp_color = wm_id - IDB_GRAY_BUTTON ;
    count = fill (current_game, turn, players[turn].pstart, tmp_color) ;
    players[turn].pcount = count ;
		players[turn].pcolor = tmp_color ;
		switch_authorized_color () ;
		update_status () ;
		if (turn == OWNER_PLAYER0) turn = OWNER_PLAYER1 ;
    else turn = OWNER_PLAYER0 ;
		// Force screen refresh
		InvalidateRect (w_handle, NULL, FALSE) ;
    if (check_end_of_game (current_game) != OWNER_NOBODY) {
			running_game = FALSE ;
      disable_buttons () ;
      // Open a modal dialog
			DialogBox (app_instance_handle,
				MAKEINTRESOURCE (IDD_DIALOG_ENDGAME), w_handle,
				(DLGPROC) EndGameDialogHandler) ;
			return ;
			}																			// End of f (check_end_of_game (current_game) != OWNER_NOBODY)

		// Now let the computer play if it has to play
    // Same code than in 'start_new_game'
    if (turn == computer_id) {
      tmp_color = computer_ai (current_game) ;
      count = fill (current_game, computer_id, players[computer_id].pstart, tmp_color) ;
			players[computer_id].pcount = count ;
			if (turn == OWNER_PLAYER0) turn = OWNER_PLAYER1 ;
      else turn = OWNER_PLAYER0 ;
			players[computer_id].pcolor = tmp_color ;
			switch_authorized_color () ;
      update_status () ;
			// Force screen refresh
			InvalidateRect (w_handle, NULL, FALSE) ;
      if (check_end_of_game (current_game) != OWNER_NOBODY) {
				running_game = FALSE ;
				disable_buttons () ;
				DialogBox (app_instance_handle, MAKEINTRESOURCE (IDD_DIALOG_ENDGAME), w_handle,
					(DLGPROC) EndGameDialogHandler) ;
				return ;
				}																			// End of if if (check_end_of_game (current_game)
			}																				// End of if (turn == computer_id)
		}																					// End of if (running_game)
}



void start_new_game (HWND w_handle)
{
	int tmp_color, count ;

	release_game (current_game) ;
  current_game = alloc_game () ;
  
	// Now, refresh the board itself
  switch_authorized_color () ;
  update_status () ;
  
	// Force screen refresh.
  InvalidateRect (w_handle, NULL, FALSE) ;
  running_game = TRUE ;
  
	// Now let the computer play if it has to play first
  // Same code than in 'handle_color_button_press'
  if (turn == computer_id) {
    tmp_color = computer_ai (current_game) ;
    count = fill (current_game, computer_id, players[computer_id].pstart, tmp_color) ;
    players[computer_id].pcount = count ;
		switch_authorized_color () ;
		update_status () ;
		turn = OWNER_PLAYER1 ;
		// Force screen refresh.
		InvalidateRect (w_handle, NULL, FALSE) ;
		players[computer_id].pcolor = tmp_color ;
		}																			// End of if (turn == computer_id)
}





LRESULT CALLBACK OptionDialogHandler (HWND w_handle, UINT message,
									  WPARAM w_param, LPARAM l_param)
{
	int wm_id, wm_event ;
	HWND tmpw_handle ;
	
	wm_id    = LOWORD (w_param) ;
	wm_event = HIWORD (w_param) ;
	
	switch (message) {
		case WM_INITDIALOG:
			tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_GAMETYPE) ;
			// Set text in the combo box for game type.
			LoadString (app_instance_handle, IDS_HUMANCOMP, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_COMPHUMAN, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_HUMANHUMAN, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			// Set ticks and initial value on the sliders.
			tmpw_handle = GetDlgItem (w_handle, IDC_SLIDER_WIDTH) ;
			SendMessage (tmpw_handle, TBM_SETRANGE, TRUE, MAKELONG (2, 16)) ;
			SendMessage (tmpw_handle, TBM_SETPOS, TRUE, (LONG) board_width) ;
			tmpw_handle = GetDlgItem (w_handle, IDC_SLIDER_HEIGHT) ;
			SendMessage (tmpw_handle, TBM_SETRANGE, TRUE, MAKELONG (2, 16)) ;
			SendMessage (tmpw_handle, TBM_SETPOS, TRUE, (LONG) board_height) ;
			tmpw_handle = GetDlgItem (w_handle, IDC_SLIDER_SPREAD) ;
			SendMessage (tmpw_handle, TBM_SETRANGE, TRUE, MAKELONG (1, 8)) ;
			SendMessage (tmpw_handle, TBM_SETPOS, TRUE, (LONG) spreading_factor) ;
			// Set board size and spreading factor in the static texts associated to scrollbars
			wsprintf (tmp_string, TEXT ("%d"), board_width) ;
			SetWindowText (GetDlgItem (w_handle, IDC_STATIC_WIDTH), tmp_string) ;
			wsprintf (tmp_string, TEXT ("%d"), board_height) ;
			SetWindowText (GetDlgItem (w_handle, IDC_STATIC_HEIGHT), tmp_string) ;
			wsprintf (tmp_string, TEXT ("%d"), spreading_factor) ;
			SetWindowText (GetDlgItem (w_handle, IDC_STATIC_SPREAD), tmp_string) ;
			// Set player names on edit boxes.
			SetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER0), players[OWNER_PLAYER0].pname) ;
			SetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER1), players[OWNER_PLAYER1].pname) ;
			// Set the game type
			tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_GAMETYPE) ;
			switch (computer_id) {
				case OWNER_PLAYER0: SendMessage (tmpw_handle, CB_SETCURSEL, 1, 0) ; break ;
				case OWNER_PLAYER1: SendMessage (tmpw_handle, CB_SETCURSEL, 0, 0) ; break ;
				case OWNER_NOBODY: SendMessage (tmpw_handle, CB_SETCURSEL, 2, 0) ; break ;
				}																					// End of switch (computer_id)
			tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_FENCES) ;
			// Set text in the combo box for fences.
			LoadString (app_instance_handle, IDS_NO_FENCE, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_ONE_VFENCE, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_TWO_VFENCES, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_ONE_HFENCE, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_TWO_HFENCES, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_CROSS_FENCE, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_TWO_VFENCESNS, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			LoadString (app_instance_handle, IDS_TWO_HFENCESNS, tmp_string, MAX_STRINGLEN) ;
			SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
			// Set the fence type
			switch (fence_style) {
				case FENCE_STYLE_NONE: SendMessage (tmpw_handle, CB_SETCURSEL, 0, 0) ; break ;
				case FENCE_STYLE_1_VERTICAL: SendMessage (tmpw_handle, CB_SETCURSEL, 1, 0) ; break ;
				case FENCE_STYLE_2_VERTICAL: SendMessage (tmpw_handle, CB_SETCURSEL, 2, 0) ; break ;
				case FENCE_STYLE_1_HORIZONTAL: SendMessage (tmpw_handle, CB_SETCURSEL, 3, 0) ; break ;
				case FENCE_STYLE_2_HORIZONTAL: SendMessage (tmpw_handle, CB_SETCURSEL, 4, 0) ; break ;
				case FENCE_STYLE_1_HORIZONTAL|FENCE_STYLE_1_VERTICAL: SendMessage (tmpw_handle, CB_SETCURSEL, 5, 0) ; break ;
				case FENCE_STYLE_2_VERTICAL_NO_SPACE: SendMessage (tmpw_handle, CB_SETCURSEL, 6, 0) ; break ;
				case FENCE_STYLE_2_HORIZONTAL_NO_SPACE: SendMessage (tmpw_handle, CB_SETCURSEL, 7, 0) ; break ;
				}																					// End of switch (fence_style)
			// Finally update the dialog window.
			ShowWindow (w_handle, SW_SHOW) ;
			UpdateWindow (w_handle) ;
			// Tells that we fully handled this message.
			return (TRUE) ;
			break ;																			// End of WM_INITDIALOG
				
		case WM_HSCROLL:
			tmpw_handle = NULL ;
			if (((HWND) l_param) == GetDlgItem (w_handle, IDC_SLIDER_WIDTH))
				tmpw_handle = GetDlgItem (w_handle, IDC_STATIC_WIDTH) ;
			else {
				if (((HWND) l_param) == GetDlgItem (w_handle, IDC_SLIDER_HEIGHT))
					tmpw_handle = GetDlgItem (w_handle, IDC_STATIC_HEIGHT) ;
				else {
					if (((HWND) l_param) == GetDlgItem (w_handle, IDC_SLIDER_SPREAD))
						tmpw_handle = GetDlgItem (w_handle, IDC_STATIC_SPREAD) ;
					}
				}
			wsprintf (tmp_string, TEXT ("%d"), SendMessage (((HWND) l_param), TBM_GETPOS, 0, 0)) ;
			if (tmpw_handle) {
				SetWindowText (tmpw_handle, tmp_string) ;
				return (TRUE) ;
				}
			else return (FALSE) ;
			break ;																			// End of WM_HSCROLL

		case WM_COMMAND:
			switch (wm_id) {
				case IDB_OPTIONSOK:
					if (MessageBox (NULL, TEXT ("This will abort the current game and begin a new one. Continue ?"),
								TEXT ("Warning"), MB_SETFOREGROUND|MB_YESNO|MB_ICONQUESTION|MB_APPLMODAL) == IDYES) {
						// Abort the current game and disable buttons
						release_game (current_game) ;
						current_game = NULL ;
						disable_buttons () ;
						// Get the board size
						board_width = SendMessage (GetDlgItem (w_handle, IDC_SLIDER_WIDTH), TBM_GETPOS, 0, 0) ;
						board_height = SendMessage (GetDlgItem (w_handle, IDC_SLIDER_HEIGHT),TBM_GETPOS, 0, 0) ;
						// Get the players names
						GetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER0), players[OWNER_PLAYER0].pname, 6) ;
						GetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER1), players[OWNER_PLAYER1].pname, 6) ;
						// Get the game type
						tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_GAMETYPE) ;
						switch (SendMessage (tmpw_handle, CB_GETCURSEL, 0, 0)) {
							case 0: computer_id = OWNER_PLAYER1 ; break ;
							case 1: computer_id = OWNER_PLAYER0 ; break ;
							case 2: computer_id = OWNER_NOBODY ; break ;
							}																			// End of switch (SendMessage (...
						// Get the fences type
						tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_FENCES) ;
						switch (SendMessage (tmpw_handle, CB_GETCURSEL, 0, 0)) {
							case 0: fence_style = FENCE_STYLE_NONE ; break ;
							case 1: fence_style = FENCE_STYLE_1_VERTICAL ; break ;
							case 2: fence_style = FENCE_STYLE_2_VERTICAL ; break ;
							case 3: fence_style = FENCE_STYLE_1_HORIZONTAL ; break ;
							case 4: fence_style = FENCE_STYLE_2_HORIZONTAL ; break ;
							case 5: fence_style = FENCE_STYLE_1_VERTICAL|FENCE_STYLE_1_HORIZONTAL ; break ;
							case 6: fence_style = FENCE_STYLE_2_VERTICAL_NO_SPACE ; break ;
							case 7: fence_style = FENCE_STYLE_2_HORIZONTAL_NO_SPACE ; break ;
							}																			// End of switch (SendMessage (...
						// Get the spreading factor.
						tmpw_handle = GetDlgItem (w_handle, IDC_SLIDER_SPREAD) ;
						spreading_factor = SendMessage (tmpw_handle, TBM_GETPOS, 0, 0) ;
						// Save into persistent preferences
						SavePrefs () ;
						// Start the new game right now...
						start_new_game (w_handle) ;
						}																				// End of if (MessageBox (NULL, ...
					// Close the modal dialog.
					EndDialog (w_handle, TRUE) ;
					// Tells that we handled the message.
					return (TRUE) ;
					break ;																		// End of IDB_OPTIONSOK
			
				case IDB_OPTIONSCANCEL:
					EndDialog (w_handle, TRUE) ;
					return (TRUE) ;
					break ;																		// End of IDB_OPTIONSCANCEL
				
				case IDC_COMBO_GAMETYPE:
					tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_GAMETYPE) ;
					switch (SendMessage (tmpw_handle, CB_GETCURSEL, 0, 0)) {
						case 0:
							// Human versus computer.
							SetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER0), TEXT ("User")) ;
							SetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER1), TEXT ("Compy")) ;
							break ;
						case 1:
							// Computer versus human.
							SetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER0), TEXT ("Compy")) ;
							SetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER1), TEXT ("User")) ;
							break ;
						case 2:
							// Human versus human.
							SetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER0), TEXT ("User1")) ;
							SetWindowText (GetDlgItem (w_handle, IDC_EDIT_PLAYER1), TEXT ("User2")) ;
							break ;
						default:
							break ;
						}																				// End of switch (SendMessage (tmpw_handle,
					return (TRUE) ;
					break ;																		// End of IDC_COMBO_GAMETYPE
				}																						// End of switch (wm_id)
			break ;																				// End of WM_COMMAND
		}																								// End switch (message)

	// Tells that we did not handle the message
	// Force default handling by the system (because we're
	// in the case of a dialog handler). Calling DefWindowProc is only the
	// protocol for window handlers
  return (FALSE) ;
}




LRESULT CALLBACK MainWindowHandler (HWND w_handle, UINT message,
				    WPARAM w_param, LPARAM l_param)
{
  int wm_id, wm_event ;

  wm_id    = LOWORD (w_param) ;
  wm_event = HIWORD (w_param) ;

  switch (message) {
		case WM_CREATE:
			SHMENUBARINFO mbi ;
			HWND cband_handle ;
			REBARBANDINFO rbi[2] ;
			HIMAGELIST disabled_imlist_handle ;						// Image list for disabled buttons
			
			// Create the menu
			memset (&mbi, 0, sizeof (SHMENUBARINFO)) ;
			mbi.cbSize = sizeof (SHMENUBARINFO) ;
			mbi.hwndParent = w_handle ;
			mbi.nToolBarId = IDMB_MAIN_MENU ;
			mbi.hInstRes = app_instance_handle ;
			mbi.nBmpId = 0 ;
			mbi.cBmpImages = 0 ;	
			SHCreateMenuBar (&mbi) ;

			// Create a command band.
			cband_handle = CommandBands_Create (app_instance_handle, w_handle, IDC_CMDBAND,
				RBS_SMARTLABELS | RBS_AUTOSIZE | RBS_VARHEIGHT, NULL) ;

			// Players' score text
			t_player_handle =
				CreateWindow (TEXT ("edit"), TEXT (""),
					WS_CHILD|WS_VISIBLE|WS_BORDER|ES_READONLY, 0, 0, 200, 16, w_handle, NULL,
					app_instance_handle, NULL) ;

			// Initialize common REBARBANDINFO structure fields.
			rbi[0].cbSize = sizeof (REBARBANDINFO) ;
			rbi[0].fMask = RBBIM_ID | RBBIM_SIZE | RBBIM_BACKGROUND | RBBIM_STYLE ;
      rbi[0].fStyle = RBBS_CHILDEDGE ;
			rbi[0].hbmBack = NULL ;
			rbi[0].wID = IDC_BAND0 ;
			rbi[0].cx = 240 ;

			rbi[1].cbSize = sizeof (REBARBANDINFO) ;
      rbi[1].fMask = RBBIM_ID | RBBIM_SIZE | RBBIM_BACKGROUND | RBBIM_STYLE |
				RBBIM_CHILD | RBBIM_CHILDSIZE ;
			rbi[1].fStyle = RBBS_CHILDEDGE ;
			rbi[1].hwndChild = t_player_handle ;
			rbi[1].cxMinChild = 0 ;
			rbi[1].cyMinChild = 16 ;		// Size of the edit control where text is displayed
			rbi[1].cx = 240 ;
			rbi[1].hbmBack = NULL ;
			rbi[1].wID = IDC_BAND1 ;

			// Add the 2 bands to the command band.
			CommandBands_AddBands (cband_handle, app_instance_handle, 2, rbi) ;

			// Add the buttons to first band.
			button_band_handle = CommandBands_GetCommandBar (cband_handle, 0) ;
			button_band_height = CommandBar_Height (button_band_handle) ;
			CommandBar_AddBitmap (button_band_handle, app_instance_handle, IDB_ENABUPBUTTONS, 7, 0, 0) ;
			CommandBar_AddButtons (button_band_handle, 7, buttons_def) ;
			disabled_imlist_handle =
				ImageList_LoadBitmap (app_instance_handle, MAKEINTRESOURCE (IDB_DISBUTTONS), 16, 7, CLR_NONE ) ;
			SendMessage (button_band_handle, TB_SETDISABLEDIMAGELIST, 0, (LPARAM) disabled_imlist_handle) ;
			disable_buttons () ;
			break ;																			// End of WM_CREATE
		
		case WM_PAINT:
			// This call handles Begin/EndPaint itself, so no need to do it here.
			refresh_screen (current_game, w_handle) ;
			break ;																			// End of WM_PAINT

		case WM_COMMAND:
			// Parse the menu selections and buttons press.
			switch (wm_id) {
				case IDMI_NEW:
					start_new_game (w_handle) ;
					break ;																	// End of IDMI_NEW

				case IDMI_OPTIONS:
					// Open a modal dialog
					DialogBox (app_instance_handle, MAKEINTRESOURCE (IDD_DIALOG_OPTIONS), w_handle,
						(DLGPROC) OptionDialogHandler) ;
					// Force screen refresh
					InvalidateRect (w_handle, NULL, FALSE) ;
					break ;																	// End of IDMI_OPTIONS
				
				case IDMI_ABOUT:
					CreateProcess (TEXT("peghelp"), TEXT("7Colors.htm"), NULL, NULL,
						FALSE, 0, NULL, NULL, NULL, NULL) ;
					break ;																	// End of IDMI_ABOUT

				case IDMI_EXIT:
					// Just triggers a WM_QUIT message that will cause the exit of the mainloop.
					PostMessage (w_handle, WM_CLOSE, 0, 0L) ;
					break ;																	// End of IDMI_EXIT
				
				case IDB_GRAY_BUTTON:
				case IDB_RED_BUTTON:
				case IDB_GREEN_BUTTON:
				case IDB_BLUE_BUTTON:
				case IDB_CYAN_BUTTON:
				case IDB_MAGENTA_BUTTON:
				case IDB_YELLOW_BUTTON:
					handle_color_button_press (wm_id, w_handle) ;
					break ;																	// End of IDB_..._BUTTON
				}																					// End of switch (wm_id)
			break ;																			// End of WM_COMMAND
				
		case WM_CLOSE:
		// Just triggers a WM_QUIT message that will make us exiting the mainloop.
		PostQuitMessage (0) ;
		break ;																				// End of WM_CLOSE
	}																								// End of switch (message)

	// Remember, window handler must call DefWindowProc to handle
	// the remaining messages. Returning TRUE or FALSE is only the protocol
	// for dialog handlers !
	return (DefWindowProc (w_handle, message, w_param, l_param)) ;
}




int WINAPI WinMain (HINSTANCE i_handle, HINSTANCE prev_i_handle,
		    LPTSTR cmd_line, int w_aspect)
	{
  MSG msg ;
  WNDCLASS wc ;
  HWND w_handle ;
  HKEY pref_key ;
  SYSTEMTIME sys_time ;
  INITCOMMONCONTROLSEX icex ;
	int i ;

  // Initialize the global variable containing the class name of the window
  LoadString (i_handle, IDS_W_CLASS_NAME, w_class_name, MAX_STRINGLEN) ;
  app_instance_handle = i_handle ;

  // Check if the game is already running. If yes then focus on the window
  w_handle = FindWindow (w_class_name, NULL) ;
  if (w_handle) {
    SetForegroundWindow (w_handle) ;
    return (0) ;
  }

  // Initialize the randomizer
  GetLocalTime (&sys_time) ;
  srand ((unsigned int) (sys_time.wSecond ^ sys_time.wMinute)) ;

  // Handle persistent preferences
  if (RegOpenKeyEx (HKEY_LOCAL_MACHINE, TEXT ("Software\\7Colors"),
	  0, 0, &pref_key) == ERROR_SUCCESS) {
	  // Preferences already exist
	  RegCloseKey (pref_key) ;
	  LoadPrefs () ;
		}
	else {
		// Preferences do not exist yet. My be it's the first time
	  // the program is running.
	  // So, first set the players name to an empty string.
	  wsprintf (players[OWNER_PLAYER0].pname, TEXT ("")) ;
	  wsprintf (players[OWNER_PLAYER1].pname, TEXT ("")) ;
	  // Then save default preferences
	  SavePrefs () ;
  }

	// Load the various bitmap we will need
  intro_bm_handle = (HBITMAP) LoadBitmap (app_instance_handle,
		MAKEINTRESOURCE (IDB_INTRO)) ;
  intro_brush = CreatePatternBrush (intro_bm_handle) ;
  prompt_bm_handle = (HBITMAP) LoadBitmap (app_instance_handle,
		MAKEINTRESOURCE (IDB_BITMAP_PROMPT)) ;

  // Register the window
  if (!prev_i_handle) {
    wc.style = CS_HREDRAW|CS_VREDRAW ;
    wc.lpfnWndProc = (WNDPROC) MainWindowHandler ;
    wc.cbClsExtra = 0 ;
    wc.cbWndExtra = 0 ;
    wc.hIcon = (HICON) LoadIcon (app_instance_handle, MAKEINTRESOURCE (IDI_ICON_7COLORS)) ;
    wc.hInstance = i_handle ;
    wc.hCursor = NULL ;
    wc.hbrBackground = intro_brush ;
    wc.lpszMenuName = NULL ;
    wc.lpszClassName = w_class_name ;
    RegisterClass (&wc) ;
  }

  // Load the command bar common control class.
  icex.dwSize = sizeof (INITCOMMONCONTROLSEX) ;
  icex.dwICC = ICC_COOL_CLASSES ;
  InitCommonControlsEx (&icex) ;

  // Create the window.
  w_handle = CreateWindow (w_class_name, TEXT ("7 Colors V1.4"),
			   WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT,
				 CW_USEDEFAULT, CW_USEDEFAULT,
				 NULL, NULL, i_handle, NULL) ;

  // Allocate brushes to paint diamonds
  color_brushes[COLOR_GRAY] = CreateSolidBrush (RGB (128, 128, 128)) ;
  color_brushes[COLOR_RED] = CreateSolidBrush (RGB (255, 0, 0)) ;
  color_brushes[COLOR_GREEN] = CreateSolidBrush (RGB (0, 255, 0)) ;
  color_brushes[COLOR_BLUE] = CreateSolidBrush (RGB (0, 0, 255)) ;
  color_brushes[COLOR_CYAN] = CreateSolidBrush (RGB (0, 255, 255)) ;
  color_brushes[COLOR_MAGENTA] = CreateSolidBrush (RGB (255, 0, 255)) ;
  color_brushes[COLOR_YELLOW] = CreateSolidBrush (RGB (255, 255, 0)) ;
  color_brushes[COLOR_BLACK] = CreateSolidBrush (RGB (0, 0, 0)) ;

  // Finally display the main window
  ShowWindow (w_handle, w_aspect) ;
  UpdateWindow (w_handle) ;

  // Entering main message loop
  while (GetMessage (&msg, NULL, 0, 0)) {
    TranslateMessage (&msg) ;
    DispatchMessage (&msg) ;
  }
  
	for (i=0; i<8; i++) DeleteObject (color_brushes[i]) ;
	DeleteObject (intro_brush) ;
	DeleteObject (intro_bm_handle) ;
	DeleteObject (prompt_bm_handle) ;
	DeleteObject (t_player_handle) ;
	release_game (current_game) ;
  return (msg.wParam) ;
}
