// *** 7 Colors for Windows CE ***
// Version 1.2
// Franois PESSAUX November 2000
// This program is freeware
// Use its sources as you whant provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot
//   --Francois

// 7Colors.cpp : Defines the entry point for the application.

#include "stdafx.h"
#include "resource.h"



void refresh_screen (struct game *game, HDC disp_dev_handle) {
  int i, line, col ;
  int x, y ;
  POINT diamond[4] ;
  struct cell *board ;
  int width, height, x0 ;

  if (current_game == NULL) {
	SetWindowText (t_player_handles[OWNER_PLAYER0], TEXT ("")) ;
	SetWindowText (t_player_handles[OWNER_PLAYER1], TEXT ("")) ;
	return ;
  }

  board = game->board ;
  width = (14 * board_width + 7) + 1 ;
  height = (14 * board_height + 7) + 1 ;
  x0 = (240 - width) / 2 ;
  y = 10 ;  // 10 : Space between top of the window and the first diamond's top
  // Draw the background of the board
  SelectObject (disp_dev_handle, GetStockObject (BLACK_BRUSH)) ;
  diamond[0].x = x0 ;
  diamond[0].y = y ;
  diamond[1].x = x0 + width ;
  diamond[1].y = y ;
  diamond[2].x = x0 + width ;
  diamond[2].y = y + height ;
  diamond[3].x = x0 ;
  diamond[3].y = y + height ;
  Polygon (disp_dev_handle, diamond, 4) ;
  // Draw the diamonds
  for (line=0; line<board_height * 2; line++) {
    if (line % 2 == 0) x = x0 + 7 ;
    else x = x0 ;
    for (col=0; col<board_width; col++) {
      diamond[0].x = x + 7 ;
      diamond[0].y = y + 1 ;
      diamond[1].x = x + 13 ;
      diamond[1].y = y + 7 ;
      diamond[2].x = x + 7 ;
      diamond[2].y = y + 13 ;
      diamond[3].x = x + 1 ;
      diamond[3].y = y + 7 ;
      i = (line * board_width) + col ;
      SelectObject (disp_dev_handle, color_brushes[board[i].color]) ;
      Polygon (disp_dev_handle, diamond, 4) ;
      x += 14 ;
    }
    y += 7 ;
  }
  // Highlight current player starting location
  SelectObject (disp_dev_handle, (HBRUSH) GetStockObject (WHITE_BRUSH)) ;
  if (turn == OWNER_PLAYER0) {
	  diamond[0].x = x0 + 7 ;
      diamond[0].y = 10 + 7 * (board_height * 2) - 7 ;
      diamond[1].x = diamond[0].x  ;
      diamond[1].y = diamond[0].y + 14 ;
      diamond[2].x = x0 ;
      diamond[2].y = diamond[0].y + 7 ;
  }
  else {
	  diamond[0].x = x0 + 14 * board_width ;
      diamond[0].y = 10 ;
      diamond[1].x = diamond[0].x ;
      diamond[1].y = diamond[0].y + 14 ;
      diamond[2].x = diamond[0].x + 7 ;
      diamond[2].y = diamond[0].y + 7 ;
  }
  Polygon (disp_dev_handle, diamond, 3) ;
}



void switch_authorized_color () {
  int i ;

  // First disable every buttons.
  for (i = COLOR_GRAY; i <= COLOR_YELLOW; i++)
    EnableWindow (b_color_handles[i], FALSE) ;
  // Now, enable some of them.
  for (i = COLOR_GRAY; i <= COLOR_YELLOW; i++) {
    if ((i != players[OWNER_PLAYER0].pcolor) &&
	(i != players[OWNER_PLAYER1].pcolor))
      EnableWindow (b_color_handles[i], TRUE) ;
  }
}



void update_status (int player_num) {
  double percent ;

  percent = ((double) (players[player_num].pcount)) /
    current_game->board_array_size * 100.0 ;
  wsprintf (tmp_string, TEXT ("%s: %2.1f %%"),
	    players[player_num].pname, percent) ;
  SetWindowText (t_player_handles[player_num], tmp_string) ;
}



LRESULT CALLBACK EndGameDialogHandler (HWND w_handle, UINT message,
				       WPARAM w_param, LPARAM l_param) {
  int wm_id ;
  double percent0, percent1 ;
  HWND tmpw_handle ;

  wm_id    = LOWORD (w_param) ;

  switch (message) {
  case WM_INITDIALOG:
    percent0 = ((double) (players[OWNER_PLAYER0].pcount)) /
      current_game->board_array_size * 100.0 ;
    percent1 = ((double) (players[OWNER_PLAYER1].pcount)) /
      current_game->board_array_size * 100.0 ;
    tmpw_handle = GetDlgItem (w_handle, IDC_STATIC_ENDGAME) ;
    if (percent0 > percent1)
      wsprintf (tmp_string, TEXT ("%s is winner !"), players[OWNER_PLAYER0].pname) ;
    else
      wsprintf (tmp_string, TEXT ("%s is winner !"), players[OWNER_PLAYER1].pname) ;
    SetWindowText (tmpw_handle, tmp_string) ;
    return (TRUE) ;
    break ;

  case WM_COMMAND:
    switch (wm_id) {
    case IDB_ENDGAME_OK:
      EndDialog (w_handle, TRUE) ;
      return (TRUE) ;
      break ;													// End of IDB_ENDGAME_OK
    }																	// End of switch (wm_id)
		break ;														// End of WM_COMMAND
  }																		// End of switch (message)

	// Force default handling by the system (because we're
	// in the case of a dialog handler). Calling DefWindowProc is only the
	// protocol for window handlers
  return (FALSE) ;
}




void handle_color_button_press (int wm_id, HWND w_handle) {
  int tmp_color, count, i ;
  HDC disp_dev_handle ;

  if (running_game) {
		tmp_color = wm_id - IDB_GRAY_BUTTON ;
    count = fill (current_game, turn, players[turn].pstart, tmp_color) ;
    players[turn].pcount = count ;
		players[turn].pcolor = tmp_color ;
		switch_authorized_color () ;
		update_status (turn) ;
		if (turn == OWNER_PLAYER0) turn = OWNER_PLAYER1 ;
    else turn = OWNER_PLAYER0 ;
    disp_dev_handle = GetWindowDC (w_handle) ;
    refresh_screen (current_game, disp_dev_handle) ;
    ReleaseDC (w_handle, disp_dev_handle) ;
    if (check_end_of_game (current_game) != OWNER_NOBODY) {
			running_game = FALSE ;
      for (i = COLOR_GRAY; i <= COLOR_YELLOW; i++)
        EnableWindow (b_color_handles[i], FALSE) ;
      // Open a modal dialog
			DialogBox (app_instance_handle,
				MAKEINTRESOURCE (IDD_DIALOG_ENDGAME), w_handle,
				(DLGPROC) EndGameDialogHandler) ;
			return ;
		}

    // Now let the computer play if it has to play
    // Same code than in 'start_new_game'
    if (turn == computer_id) {
      tmp_color = computer_ai (current_game) ;
      count = fill (current_game, computer_id, players[computer_id].pstart, tmp_color) ;
			players[computer_id].pcount = count ;
			if (turn == OWNER_PLAYER0) turn = OWNER_PLAYER1 ;
      else turn = OWNER_PLAYER0 ;
			players[computer_id].pcolor = tmp_color ;
			switch_authorized_color () ;
      update_status (computer_id) ;
      disp_dev_handle = GetWindowDC (w_handle) ;
      refresh_screen (current_game, disp_dev_handle) ;
      ReleaseDC (w_handle, disp_dev_handle) ;
      if (check_end_of_game (current_game) != OWNER_NOBODY) {
				running_game = FALSE ;
				for (i = COLOR_GRAY; i <= COLOR_YELLOW; i++)
					EnableWindow (b_color_handles[i], FALSE) ;
				DialogBox (app_instance_handle,
					MAKEINTRESOURCE (IDD_DIALOG_ENDGAME), w_handle,
					(DLGPROC) EndGameDialogHandler) ;
				return ;
			}
    }
  }
}



void start_new_game (HWND w_handle) {
  int tmp_color, count ;
  HDC disp_dev_handle ;
  RECT rect = { 0, 0, 240, 208 } ;

  release_game (current_game) ;
  current_game = alloc_game () ;
  disp_dev_handle = GetWindowDC (w_handle) ;
  // Now, refresh the board itself
  switch_authorized_color () ;
  update_status (OWNER_PLAYER0) ;
  update_status (OWNER_PLAYER1) ;
  refresh_screen (current_game, disp_dev_handle) ;
  ReleaseDC (w_handle, disp_dev_handle) ;
  running_game = TRUE ;
  // Now let the computer play if it has to play first
  // Same code than in 'handle_color_button_press'
  if (turn == computer_id) {
    tmp_color = computer_ai (current_game) ;
    count = fill (current_game, computer_id, players[computer_id].pstart, tmp_color) ;
    players[computer_id].pcount = count ;
    disp_dev_handle = GetWindowDC (w_handle) ;
	switch_authorized_color () ;
    update_status (computer_id) ;
	turn = OWNER_PLAYER1 ;
    refresh_screen (current_game, disp_dev_handle) ;
    ReleaseDC (w_handle, disp_dev_handle) ;
    players[computer_id].pcolor = tmp_color ;
  }
}





LRESULT CALLBACK OptionDialogHandler (HWND w_handle, UINT message,
																			WPARAM w_param, LPARAM l_param)
{
	int i, wm_id, wm_event ;
  HWND tmpw_handle ;

  wm_id    = LOWORD (w_param) ;
  wm_event = HIWORD (w_param) ;

  switch (message) {
	case WM_INITDIALOG:
		tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_GAMETYPE) ;
    // Set text in the combo box
    LoadString (app_instance_handle, IDS_HUMANCOMP, tmp_string, MAX_STRINGLEN) ;
    SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
    LoadString (app_instance_handle, IDS_COMPHUMAN, tmp_string, MAX_STRINGLEN) ;
    SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
    LoadString (app_instance_handle, IDS_HUMANHUMAN, tmp_string, MAX_STRINGLEN) ;
    SendMessage (tmpw_handle, CB_ADDSTRING, 0, (LPARAM) tmp_string) ;
    // Set ticks and initial value on the sliders
    tmpw_handle = GetDlgItem (w_handle, IDC_SLIDER_WIDTH) ;
    SendMessage (tmpw_handle, TBM_SETRANGE, TRUE, MAKELONG (2, 16)) ;
		SendMessage (tmpw_handle, TBM_SETPOS, TRUE, (LONG) board_width) ;
    tmpw_handle = GetDlgItem (w_handle, IDC_SLIDER_HEIGHT) ;
    SendMessage (tmpw_handle, TBM_SETRANGE, TRUE, MAKELONG (2, 12)) ;
		SendMessage (tmpw_handle, TBM_SETPOS, TRUE, (LONG) board_height) ;
		// Set board size in the static texts associated to scrollbars
		wsprintf (tmp_string, TEXT ("%d"),board_width) ;
		SetWindowText (GetDlgItem (w_handle, IDC_STATIC_WIDTH), tmp_string) ;
		wsprintf (tmp_string, TEXT ("%d"),board_height) ;
		SetWindowText (GetDlgItem (w_handle, IDC_STATIC_HEIGHT), tmp_string) ;
		// Set player names on edit boxes
    tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER0) ;
		SetWindowText (tmpw_handle, players[OWNER_PLAYER0].pname) ;
    tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER1) ;
		SetWindowText (tmpw_handle, players[OWNER_PLAYER1].pname) ;
		// Set the game type
		tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_GAMETYPE) ;
		switch (computer_id) {
		case OWNER_PLAYER0: SendMessage (tmpw_handle, CB_SETCURSEL, 1, 0) ; break ;
		case OWNER_PLAYER1: SendMessage (tmpw_handle, CB_SETCURSEL, 0, 0) ; break ;
		case OWNER_NOBODY: SendMessage (tmpw_handle, CB_SETCURSEL, 2, 0) ; break ;
		}																// End of switch (computer_id)
    ShowWindow (w_handle, SW_SHOW) ;
    UpdateWindow (w_handle) ;
		// Tell that we fully handled this message
		return (TRUE) ;
    break ;													// End of WM_INITDIALOG

  case WM_HSCROLL:
    tmpw_handle = NULL ;
    if (((HWND) l_param) == GetDlgItem (w_handle, IDC_SLIDER_WIDTH))
			tmpw_handle = GetDlgItem (w_handle, IDC_STATIC_WIDTH) ;
		else {
			if (((HWND) l_param) == GetDlgItem (w_handle, IDC_SLIDER_HEIGHT))
				tmpw_handle = GetDlgItem (w_handle, IDC_STATIC_HEIGHT) ;
		}
		wsprintf (tmp_string, TEXT ("%d"),
			SendMessage (((HWND) l_param), TBM_GETPOS, 0, 0)) ;
		if (tmpw_handle) {
			SetWindowText (tmpw_handle, tmp_string) ;
			return (TRUE) ;
		}
		else return (FALSE) ;
		break ;													// End of WM_HSCROLL

  case WM_COMMAND:
    switch (wm_id) {
    case IDB_OPTIONSOK:
			if (MessageBox (NULL,
					TEXT ("This will abort the current game. Continue ?"),
					TEXT ("About"),
					MB_SETFOREGROUND|MB_YESNO|MB_ICONQUESTION|MB_APPLMODAL) == IDYES) {
				// Abort the current game and disable buttons
				release_game (current_game) ;
				current_game = NULL ;
				for (i = COLOR_GRAY; i <= COLOR_YELLOW; i++)
					EnableWindow (b_color_handles[i], FALSE) ;
				// Get the board size
				tmpw_handle = GetDlgItem (w_handle, IDC_SLIDER_WIDTH) ;
				board_width = SendMessage (tmpw_handle, TBM_GETPOS, 0, 0) ;
				tmpw_handle = GetDlgItem (w_handle, IDC_SLIDER_HEIGHT) ;
				board_height = SendMessage (tmpw_handle,TBM_GETPOS, 0, 0) ;
				// Get the players names
				tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER0) ;
				GetWindowText (tmpw_handle, players[OWNER_PLAYER0].pname, 5) ;
				tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER1) ;
				GetWindowText (tmpw_handle, players[OWNER_PLAYER1].pname, 5) ;
				// Get the game type
				tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_GAMETYPE) ;
				switch (SendMessage (tmpw_handle, CB_GETCURSEL, 0, 0)) {
				case 0: computer_id = OWNER_PLAYER1 ; break ;
				case 1: computer_id = OWNER_PLAYER0 ; break ;
				case 2: computer_id = OWNER_NOBODY ; break ;
				}															// End of switch (SendMessage (...
				// Save into persistent preferences
				SavePrefs () ;
			}																// End of if (MessageBox (NULL, ...
			// Close the modal dialog
			EndDialog (w_handle, TRUE) ;
			// Tells that we handled the message
			return (TRUE) ;
			break ;													// End of IDB_OPTIONSOK
		
		case IDB_OPTIONSCANCEL:
			EndDialog (w_handle, TRUE) ;
      return (TRUE) ;
      break ;													// End of IDB_OPTIONSCANCEL

    case IDC_COMBO_GAMETYPE:
			tmpw_handle = GetDlgItem (w_handle, IDC_COMBO_GAMETYPE) ;
			switch (SendMessage (tmpw_handle, CB_GETCURSEL, 0, 0)) {
			case 0:
				// Human versus computer
				tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER0) ;
				SetWindowText (tmpw_handle, players[OWNER_PLAYER0].pname) ;
				tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER1) ;
				SetWindowText (tmpw_handle, TEXT ("Ipaq")) ;
				break ;
			case 1:
				// Computer versus human
				tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER0) ;
				SetWindowText (tmpw_handle, TEXT ("Ipaq")) ;
				tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER1) ;
				SetWindowText (tmpw_handle, players[OWNER_PLAYER1].pname) ;
				break ;
			case 2:
				// Human versus human
				tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER0) ;
				SetWindowText (tmpw_handle, players[OWNER_PLAYER0].pname) ;
				tmpw_handle = GetDlgItem (w_handle, IDC_EDIT_PLAYER1) ;
				SetWindowText (tmpw_handle, players[OWNER_PLAYER1].pname) ;
				break ;
			default:
				break ;
			}													// End of switch (SendMessage (tmpw_handle,

			return (TRUE) ;
			break ;										// End of IDC_COMBO_GAMETYPE
		}
		break ;											// End of WM_COMMAND
  }															// End switch (message) {

  // Tells that we did not handle the message
	// Force default handling by the system (because we're
	// in the case of a dialog handler). Calling DefWindowProc is only the
	// protocol for window handlers
  return (FALSE) ;
}




LRESULT CALLBACK MainWindowHandler (HWND w_handle, UINT message,
				    WPARAM w_param, LPARAM l_param)
{
  int wm_id, wm_event ;
  int i ;

  wm_id    = LOWORD (w_param) ;
  wm_event = HIWORD (w_param) ;

  switch (message) {
	case WM_CREATE:
		SHMENUBARINFO mbi ;

		// Create the menu
		memset (&mbi, 0, sizeof (SHMENUBARINFO)) ;
    mbi.cbSize = sizeof (SHMENUBARINFO) ;
    mbi.hwndParent = w_handle ;
    mbi.nToolBarId = IDMB_MAIN_MENU ;
    mbi.hInstRes = app_instance_handle ;
    mbi.nBmpId = 0 ;
    mbi.cBmpImages = 0 ;	
    SHCreateMenuBar (&mbi) ;
		// Create the buttons
    b_color_handles[COLOR_GRAY] =
      CreateWindow (TEXT ("button"), TEXT ("Gray"),
		    WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW, 
		    20, 240, BUTTONWIDTH, BUTTONHEIGHT, w_handle, 
		    (HMENU) IDB_GRAY_BUTTON,
		    app_instance_handle, NULL) ;
    b_color_handles[COLOR_RED] =
      CreateWindow (TEXT ("button"), TEXT ("Red"),
		    WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW, 
		    50, 240, BUTTONWIDTH, BUTTONHEIGHT, w_handle, 
		    (HMENU) IDB_RED_BUTTON,
		    app_instance_handle, NULL) ;
    b_color_handles[COLOR_GREEN] =
      CreateWindow (TEXT ("button"), TEXT ("Green"),
		    WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW, 
		    80, 240, BUTTONWIDTH, BUTTONHEIGHT, w_handle, 
		    (HMENU) IDB_GREEN_BUTTON,
		    app_instance_handle, NULL) ;
    b_color_handles[COLOR_BLUE] =
      CreateWindow (TEXT ("button"), TEXT ("Blue"),
		    WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW, 
		    110, 240, BUTTONWIDTH, BUTTONHEIGHT, w_handle, 
		    (HMENU) IDB_BLUE_BUTTON,
		    app_instance_handle, NULL) ;
    b_color_handles[COLOR_CYAN] =
      CreateWindow (TEXT ("button"), TEXT ("Cyan"),
		    WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW, 
		    140, 240, BUTTONWIDTH, BUTTONHEIGHT, w_handle, 
		    (HMENU) IDB_CYAN_BUTTON,
		    app_instance_handle, NULL) ;
    b_color_handles[COLOR_MAGENTA] =
      CreateWindow (TEXT ("button"), TEXT ("Magenta"),
		    WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW, 
		    170, 240, BUTTONWIDTH, BUTTONHEIGHT, w_handle, 
		    (HMENU) IDB_MAGENTA_BUTTON,
		    app_instance_handle, NULL) ;
    b_color_handles[COLOR_YELLOW] =
      CreateWindow (TEXT ("button"), TEXT ("Yellow"),
		    WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW, 
		    200, 240, BUTTONWIDTH, BUTTONHEIGHT, w_handle, 
		    (HMENU) IDB_YELLOW_BUTTON,
		    app_instance_handle, NULL) ;

    t_player_handles[OWNER_PLAYER0] =
      CreateWindow (TEXT ("static"), players[OWNER_PLAYER0].pname,
		    WS_CHILD|WS_VISIBLE|WS_BORDER, 
		    10, 212, 100, 20, w_handle, 
		    NULL, app_instance_handle, NULL) ;
    t_player_handles[OWNER_PLAYER1] =
      CreateWindow (TEXT ("static"), players[OWNER_PLAYER1].pname,
		    WS_CHILD|WS_VISIBLE|WS_BORDER, 
		    130, 212, 100, 20, w_handle, 
		    NULL, app_instance_handle, NULL) ;

    for (i = COLOR_GRAY; i <= COLOR_YELLOW; i++)
      EnableWindow (b_color_handles[i], FALSE) ;
		break ;														// End of WM_CREATE

  case WM_PAINT: {
    PAINTSTRUCT paint_struct ;
    BeginPaint (w_handle, &paint_struct) ;
    refresh_screen (current_game, paint_struct.hdc) ;
    EndPaint (w_handle, &paint_struct) ;
		}																	// End local block for WM_PAINT
		break ;														// End of WM_PAINT

  case WM_COMMAND:
    // Parse the menu selections and buttons press
    switch (wm_id) {
    case IDMI_NEW:
      start_new_game (w_handle) ;
      break ;

    case IDMI_OPTIONS: {
      // Open a modal dialog
      DialogBox (app_instance_handle,
		 MAKEINTRESOURCE (IDD_DIALOG_OPTIONS), w_handle,
		 (DLGPROC) OptionDialogHandler) ;
      break ;													// End of IDMI_OPTIONS
    }
    break ;

    case IDMI_ABOUT:
			CreateProcess (TEXT("peghelp"), TEXT("7Colors.htm"), NULL, NULL,
					FALSE, 0, NULL, NULL, NULL, NULL) ;
			return (TRUE) ;
			break ;													// End of IDMI_ABOUT

    case IDMI_EXIT:
			// Just triggers a WM_QUIT message that will cause the exit of the mainloop.
      PostMessage (w_handle, WM_CLOSE, 0, 0L) ;
			return (TRUE) ;
      break ;													// End of IDMI_EXIT

    case IDB_GRAY_BUTTON:
    case IDB_RED_BUTTON:
    case IDB_GREEN_BUTTON:
    case IDB_BLUE_BUTTON:
    case IDB_CYAN_BUTTON:
    case IDB_MAGENTA_BUTTON:
    case IDB_YELLOW_BUTTON:
      handle_color_button_press (wm_id, w_handle) ;
      break ;													// End of IDB_..._BUTTON
    }
		break ;														// End of WM_COMMAND
		
  case WM_DRAWITEM: {
    LPDRAWITEMSTRUCT lpdis;
    HDC tmp_hdc ;
    int tmp_color ;

    tmp_color = wm_id - IDB_GRAY_BUTTON ;
    lpdis = (LPDRAWITEMSTRUCT) l_param ;
    tmp_hdc = CreateCompatibleDC ((HDC) lpdis->hDC) ;
    if (lpdis->itemState & ODS_DISABLED)      // Button is disabled
      SelectBitmap (tmp_hdc, dis_bm_handles[tmp_color]) ;
    else {
			if (lpdis->itemState & ODS_SELECTED)	// Button is pressed
				SelectBitmap (tmp_hdc, down_bm_handles[tmp_color]) ;
			else	                                // Button is released
				SelectBitmap (tmp_hdc, up_bm_handles[tmp_color]) ;
		}
		
		BitBlt (lpdis->hDC, lpdis->rcItem.left, lpdis->rcItem.top,
			lpdis->rcItem.right - lpdis->rcItem.left,
	    lpdis->rcItem.bottom - lpdis->rcItem.top, tmp_hdc,0, 0,
	    SRCCOPY) ;
    DeleteDC (tmp_hdc) ;
		}																	// End of local block for WM_DRAWITEM
		break ;														// End of WM_DRAWITEM

  default:
		// Remember, window handler must call DefWindowProc to handle
		// the remaining messages. Returning TRUE or FALSE is only the protocol
		// for dialog handlers !
    return (DefWindowProc (w_handle, message, w_param, l_param)) ;
    break ;
  }

  return (FALSE) ;										// Dead code indeed
}




int WINAPI WinMain (HINSTANCE i_handle, HINSTANCE prev_i_handle,
		    LPTSTR cmd_line, int w_aspect) {
  MSG msg ;
  WNDCLASS wc ;
  HWND w_handle ;
  HKEY pref_key ;
  SYSTEMTIME sys_time ;
	int i ;

  // Initialize the global variable containing the class name of the window
  LoadString (i_handle, IDS_W_CLASS_NAME, w_class_name, MAX_STRINGLEN) ;
  app_instance_handle = i_handle ;

  // Check if the game is already running. If yes then focus on the window
  w_handle = FindWindow (w_class_name, NULL) ;
  if (w_handle) {
    SetForegroundWindow (w_handle) ;
    return (0) ;
  }

  // Initialize the randomizer
  GetLocalTime (&sys_time) ;
  srand ((unsigned int) sys_time.wMilliseconds) ;

  // Handle persistent preferences
  if (RegOpenKeyEx (HKEY_LOCAL_MACHINE, TEXT ("Software\\7Colors"),
	  0, 0, &pref_key) == ERROR_SUCCESS) {
	  // Preferences already exist
	  RegCloseKey (pref_key) ;
	  LoadPrefs () ;
  }
  else {
	  // Preferences do not exist yet. My be it's the first time
	  // the program is running.
	  // So, first set the players name to an empty string.
	  wsprintf (players[OWNER_PLAYER0].pname, TEXT ("")) ;
	  wsprintf (players[OWNER_PLAYER1].pname, TEXT ("")) ;
	  // Then save default preferences
	  SavePrefs () ;
  }

  intro_bm_handle = (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_INTRO)) ;
  intro_brush = CreatePatternBrush (intro_bm_handle) ;

  // Register the window
  if (! prev_i_handle) {
    wc.style = CS_HREDRAW|CS_VREDRAW ;
    wc.lpfnWndProc = (WNDPROC) MainWindowHandler ;
    wc.cbClsExtra = 0 ;
    wc.cbWndExtra = 0 ;
    wc.hIcon = (HICON) LoadIcon (app_instance_handle, MAKEINTRESOURCE (IDI_ICON_7COLORS)) ;
    wc.hInstance = i_handle ;
    wc.hCursor = NULL ;
    wc.hbrBackground = intro_brush ;
    wc.lpszMenuName = NULL ;
    wc.lpszClassName = w_class_name ;
    RegisterClass (&wc) ;
  }

  // Create the window
  w_handle = CreateWindow (w_class_name, TEXT ("7 Colors"),
			   WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT,
			   CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, i_handle,
			   NULL) ;

  // Allocate brushes to paint diamonds
  color_brushes[COLOR_GRAY] = CreateSolidBrush (RGB (128, 128, 128)) ;
  color_brushes[COLOR_RED] = CreateSolidBrush (RGB (255, 0, 0)) ;
  color_brushes[COLOR_GREEN] = CreateSolidBrush (RGB (0, 255, 0)) ;
  color_brushes[COLOR_BLUE] = CreateSolidBrush (RGB (0, 0, 255)) ;
  color_brushes[COLOR_CYAN] = CreateSolidBrush (RGB (0, 255, 255)) ;
  color_brushes[COLOR_MAGENTA] = CreateSolidBrush (RGB (255, 0, 255)) ;
  color_brushes[COLOR_YELLOW] = CreateSolidBrush (RGB (255, 255, 0)) ;

  // Allocate bitmaps to paint buttons
  up_bm_handles[COLOR_GRAY] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_GRAY_UP)) ;
  down_bm_handles[COLOR_GRAY] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_GRAY_DOWN)) ;
  dis_bm_handles[COLOR_GRAY] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_GRAY_DIS)) ;
  up_bm_handles[COLOR_RED] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_RED_UP)) ;
  down_bm_handles[COLOR_RED] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE(IDB_RED_DOWN)) ;
  dis_bm_handles[COLOR_RED] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_RED_DIS)) ;
  up_bm_handles[COLOR_GREEN] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_GREEN_UP)) ;
  down_bm_handles[COLOR_GREEN] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_GREEN_DOWN)) ;
  dis_bm_handles[COLOR_GREEN] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_GREEN_DIS)) ;
  up_bm_handles[COLOR_BLUE] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_BLUE_UP)) ;
  down_bm_handles[COLOR_BLUE] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE(IDB_BLUE_DOWN)) ;
  dis_bm_handles[COLOR_BLUE] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_BLUE_DIS)) ;
  up_bm_handles[COLOR_CYAN] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_CYAN_UP)) ;
  down_bm_handles[COLOR_CYAN] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE(IDB_CYAN_DOWN)) ;
  dis_bm_handles[COLOR_CYAN] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_CYAN_DIS)) ;
  up_bm_handles[COLOR_MAGENTA] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_MAGENTA_UP)) ;
  down_bm_handles[COLOR_MAGENTA] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE(IDB_MAGENTA_DOWN)) ;
  dis_bm_handles[COLOR_MAGENTA] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_MAGENTA_DIS)) ;
  up_bm_handles[COLOR_YELLOW] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_YELLOW_UP)) ;
  down_bm_handles[COLOR_YELLOW] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE(IDB_YELLOW_DOWN)) ;
  dis_bm_handles[COLOR_YELLOW] =
    (HBITMAP) LoadBitmap (app_instance_handle,
			  MAKEINTRESOURCE (IDB_YELLOW_DIS)) ;
  // Finally display the main window
  ShowWindow (w_handle, w_aspect) ;
  UpdateWindow (w_handle) ;
  // Entering main message loop
  while (GetMessage (&msg, NULL, 0, 0)) {
    TranslateMessage (&msg) ;
    DispatchMessage (&msg) ;
  }
  
	// End of the program...
	for (i = COLOR_GRAY; i <= COLOR_YELLOW; i++) {
		DeleteObject (up_bm_handles[i]) ;
     DeleteObject (down_bm_handles[i]) ;
     DeleteObject (b_color_handles[i]) ;
	}

	DeleteObject (intro_brush) ;
	DeleteObject (intro_bm_handle) ;
	DeleteObject (t_player_handles[OWNER_PLAYER0]) ;
	DeleteObject (t_player_handles[OWNER_PLAYER1]) ;
	release_game (current_game) ;
  return (msg.wParam) ;
}

