// *** 7 Colors for Windows CE ***
// Version 1.4
// Franois PESSAUX June 2001
// This program is freeware
// Use its sources as you want provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot
//   --Francois
#include "stdafx.h"


void LoadPrefs ()
{
  HKEY pref_key ;
  DWORD tmp1, tmp2 ;

  if (RegOpenKeyEx (HKEY_LOCAL_MACHINE, TEXT ("Software\\7Colors"),
		0, 0, &pref_key) != ERROR_SUCCESS) {
	  return ;
  }

  // First, get the board size
  RegQueryValueEx (pref_key, TEXT ("width"), NULL, &tmp1,
	  (LPBYTE) &board_width, &tmp2) ;
  RegQueryValueEx (pref_key, TEXT ("height"), NULL, &tmp1,
	  (LPBYTE) &board_height, &tmp2) ;
  // Now get the players names
	tmp2 = 6 * sizeof (TCHAR) ;
  RegQueryValueEx (pref_key, TEXT ("player0"), NULL, &tmp1,
	  (LPBYTE) players[OWNER_PLAYER0].pname, &tmp2) ;
	tmp2 = 6 * sizeof (TCHAR) ;
  RegQueryValueEx (pref_key, TEXT ("player1"), NULL, &tmp1,
	  (LPBYTE) players[OWNER_PLAYER1].pname, &tmp2) ;
  // Now, get the game type
  RegQueryValueEx (pref_key, TEXT ("gametype"), NULL, &tmp1,
	  (LPBYTE) &computer_id, &tmp2) ;
	// Now, get the fence type
  RegQueryValueEx (pref_key, TEXT ("fencetype"), NULL, &tmp1,
	  (LPBYTE) &fence_style, &tmp2) ;
	// Now, get the spreading_factor
  RegQueryValueEx (pref_key, TEXT ("spreadingfactor"), NULL, &tmp1,
	  (LPBYTE) &spreading_factor, &tmp2) ;
  // Now, close the key
  RegCloseKey (pref_key) ;
  return ;
}



void SavePrefs ()
{
  HKEY pref_key ;
  DWORD tmp ;

  // Initialize persistent preferences
  RegCreateKeyEx (HKEY_LOCAL_MACHINE, TEXT ("Software\\7Colors"), 0, NULL,
	  0, 0, NULL, &pref_key, &tmp) ;
  // First, store board size
  RegSetValueEx (pref_key, TEXT ("width"), 0, REG_DWORD,
	  (LPBYTE) &board_width, sizeof (int)) ;
  RegSetValueEx (pref_key, TEXT ("height"), 0, REG_DWORD,
	  (LPBYTE) &board_height, sizeof (int)) ;
  // Now, save player names
  RegSetValueEx (pref_key, TEXT ("player0"), 0, REG_SZ,
	  (LPBYTE) players[OWNER_PLAYER0].pname, 6 * sizeof (TCHAR)) ;
  RegSetValueEx (pref_key, TEXT ("player1"), 0, REG_SZ,
	  (LPBYTE) players[OWNER_PLAYER1].pname, 6 * sizeof (TCHAR)) ;
  // And now the type of game
  RegSetValueEx (pref_key, TEXT ("gametype"), 0, REG_DWORD,
	  (LPBYTE) &computer_id, sizeof (int)) ;
	  // And now the type of fences
  RegSetValueEx (pref_key, TEXT ("fencetype"), 0, REG_DWORD,
	  (LPBYTE) &fence_style, sizeof (int)) ;
	// And now the spreading factor
  RegSetValueEx (pref_key, TEXT ("spreadingfactor"), 0, REG_DWORD,
	  (LPBYTE) &spreading_factor, sizeof (int)) ;
  // Now, close the key
  RegCloseKey (pref_key) ;
  return ;
}
